StaticTypesWriterController (groovy 2.4.9 API)
Date: 2017-02-24

Package: org.codehaus.groovy.classgen.asm.sc

## [Java] Class StaticTypesWriterController

- org.codehaus.groovy.classgen.asm.sc.StaticTypesWriterController

- An alternative WriterController which handles static types and method dispatch. In case of a "mixed mode" where only some methods are annotated with TypeChecked then this writer will delegate to the classic writer controller.

  Authors:
    Cedric Champeau

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected boolean` | `isInStaticallyCheckedMethod` |

  - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class DelegatingController` | `optimizeForInt`
    `class WriterController` | `optimizeForInt`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `StaticTypesWriterController (WriterController normalController)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `BinaryExpressionHelper` | `getBinaryExpressionHelper()`
    `` | `CallSiteWriter` | `getCallSiteWriter()`
    `` | `ClosureWriter` | `getClosureWriter()`
    `` | `InvocationWriter` | `getInvocationWriter()`
    `` | `CallSiteWriter` | `getRegularCallSiteWriter()`
    `` | `InvocationWriter` | `getRegularInvocationWriter()`
    `` | `StatementWriter` | `getStatementWriter()`
    `` | `TypeChooser` | `getTypeChooser()`
    `` | `UnaryExpressionHelper` | `getUnaryExpressionHelper()`
    `` | `void` | `init(AsmClassGenerator asmClassGenerator, GeneratorContext gcon, org.objectweb.asm.ClassVisitor cv, ClassNode cn)`
    `` | `boolean` | `isFastPath()`
    `` | `void` | `setConstructorNode(ConstructorNode cn)`
    `` | `void` | `setMethodNode(MethodNode mn)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class DelegatingController` | `getReturnType, isConstructor, init, getContext, getClassName, getLineNumber, isFastPath, getClassNode, isStaticConstructor, setLineNumber, getUnaryExpressionHelper, getConstructorNode, getCallSiteWriter, getInternalClassName, setInterfaceClassLoadingClass, getStatementWriter, getBytecodeVersion, getInternalBaseClassName, isInClosureConstructor, isNotExplicitThisInClosure, getAssertionWriter, shouldOptimizeForInt, getInvocationWriter, setConstructorNode, getInterfaceClassLoadingClass, getOutermostClass, getBinaryExpressionHelper, getSourceUnit, getClassVisitor, setMethodNode, getClosureWriter, getCompileStack, getTypeChooser, getAcg, isStaticMethod, isStaticContext, isInScriptBody, isInClosure, resetLineNumber, switchToSlowPath, isNotClinit, switchToFastPath, getOperandStack, getMethodNode, getCv, setMethodVisitor, getMethodVisitor, getNextHelperMethodIndex, getSuperMethodNames, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`
    `class WriterController` | `getReturnType, isConstructor, init, getContext, getClassName, getLineNumber, isFastPath, getClassNode, isStaticConstructor, setLineNumber, getUnaryExpressionHelper, getNextHelperMethodIndex, getConstructorNode, getCallSiteWriter, getInternalClassName, setInterfaceClassLoadingClass, getStatementWriter, getBytecodeVersion, getInternalBaseClassName, isInClosureConstructor, isNotExplicitThisInClosure, getAssertionWriter, shouldOptimizeForInt, getInvocationWriter, setConstructorNode, getInterfaceClassLoadingClass, getOutermostClass, getSuperMethodNames, getBinaryExpressionHelper, getSourceUnit, getClassVisitor, setMethodNode, getClosureWriter, getCompileStack, getTypeChooser, getAcg, isStaticMethod, isStaticContext, isInScriptBody, isInClosure, resetLineNumber, switchToSlowPath, isNotClinit, switchToFastPath, getOperandStack, getMethodNode, getCv, setMethodVisitor, getMethodVisitor, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### protected boolean isInStaticallyCheckedMethod

  - ### Constructor Detail

    - #### public StaticTypesWriterController(WriterController normalController)

  - ### Method Detail

    - #### @Override public BinaryExpressionHelper getBinaryExpressionHelper()

    - #### @Override public CallSiteWriter getCallSiteWriter()

    - #### @Override public ClosureWriter getClosureWriter()

    - #### @Override public InvocationWriter getInvocationWriter()

    - #### public CallSiteWriter getRegularCallSiteWriter()

    - #### public InvocationWriter getRegularInvocationWriter()

    - #### @Override public StatementWriter getStatementWriter()

    - #### @Override public TypeChooser getTypeChooser()

    - #### @Override public UnaryExpressionHelper getUnaryExpressionHelper()

    - #### @Override public void init(AsmClassGenerator asmClassGenerator, GeneratorContext gcon, org.objectweb.asm.ClassVisitor cv, ClassNode cn)

    - #### @Override public boolean isFastPath()

    - #### @Override public void setConstructorNode(ConstructorNode cn)

    - #### @Override public void setMethodNode(MethodNode mn)